## crowdsec 1.0.9

=== Makefile ===
PREFIX?="/tmp/crowdsec/"
CFG_PREFIX = $(PREFIX)"/etc/crowdsec/"
BIN_PREFIX = $(PREFIX)"/usr/local/bin/"
DATA_PREFIX = $(PREFIX)"/var/run/crowdsec/"

PID_DIR = $(PREFIX)"/var/run/"
CROWDSEC_FOLDER = "./cmd/crowdsec"
CSCLI_FOLDER = "./cmd/crowdsec-cli/"
CROWDSEC_BIN = "crowdsec"
CSCLI_BIN = "cscli"
BUILD_CMD = "build"
MAKE = "make"

GOARCH=amd64
GOOS=linux

#Golang version info
GO_MAJOR_VERSION = $(shell go version | cut -c 14- | cut -d' ' -f1 | cut -d'.' -f1)
GO_MINOR_VERSION = $(shell go version | cut -c 14- | cut -d' ' -f1 | cut -d'.' -f2)
MINIMUM_SUPPORTED_GO_MAJOR_VERSION = 1
MINIMUM_SUPPORTED_GO_MINOR_VERSION = 13
GO_VERSION_VALIDATION_ERR_MSG = Golang version ($(BUILD_GOVERSION)) is not supported, please use least $(MINIMUM_SUPPORTED_GO_MAJOR_VERSION).$(MINIMUM_SUPPORTED_GO_MINOR_VERSION)
#Current versioning information from env
BUILD_VERSION?="$(shell git describe --tags `git rev-list --tags --max-count=1`)"
BUILD_GOVERSION="$(shell go version | cut -d " " -f3 | sed -r 's/[go]+//g')"
BUILD_CODENAME=$(shell cat RELEASE.json | jq -r .CodeName)
BUILD_TIMESTAMP=$(shell date +%F"_"%T)
BUILD_TAG="$(shell git rev-parse HEAD)"
export LD_OPTS=-ldflags "-s -w -X github.com/crowdsecurity/crowdsec/pkg/cwversion.Version=$(BUILD_VERSION) \
-X github.com/crowdsecurity/crowdsec/pkg/cwversion.BuildDate=$(BUILD_TIMESTAMP) \
-X github.com/crowdsecurity/crowdsec/pkg/cwversion.Codename=$(BUILD_CODENAME)  \
-X github.com/crowdsecurity/crowdsec/pkg/cwversion.Tag=$(BUILD_TAG) \
-X github.com/crowdsecurity/crowdsec/pkg/cwversion.GoVersion=$(BUILD_GOVERSION)"
RELDIR = crowdsec-$(BUILD_VERSION)

all: clean test build

build: goversion crowdsec cscli

static: goversion crowdsec_static cscli_static

goversion:
	@if [ $(GO_MAJOR_VERSION) -gt $(MINIMUM_SUPPORTED_GO_MAJOR_VERSION) ]; then \
        exit 0 ;\
    elif [ $(GO_MAJOR_VERSION) -lt $(MINIMUM_SUPPORTED_GO_MAJOR_VERSION) ]; then \
        echo '$(GO_VERSION_VALIDATION_ERR_MSG)';\
        exit 1; \
    elif [ $(GO_MINOR_VERSION) -lt $(MINIMUM_SUPPORTED_GO_MINOR_VERSION) ] ; then \
        echo '$(GO_VERSION_VALIDATION_ERR_MSG)';\
        exit 1; \
    fi

hubci:
	@rm -rf crowdsec-xxx hub-tests
	BUILD_VERSION=xxx make release
	@git clone https://github.com/crowdsecurity/hub-tests.git
	@cd hub-tests && make
	@cd crowdsec-xxx && ./test_env.sh
	@cd crowdsec-xxx/tests && bash ../../scripts/install_all.sh
	@cp hub-tests/main ./crowdsec-xxx/tests/
	@cp -R hub-tests/tests ./crowdsec-xxx/tests/
	@cd ./crowdsec-xxx/tests/ && bash ../../hub-tests/run_tests.sh

clean:
	@$(MAKE) -C $(CROWDSEC_FOLDER) clean --no-print-directory
	@$(MAKE) -C $(CSCLI_FOLDER) clean --no-print-directory
	@rm -f $(CROWDSEC_BIN)
	@rm -f $(CSCLI_BIN)
	@rm -f *.log
	@rm -f crowdsec-release.tgz

cscli:
ifeq ($(lastword $(RESPECT_VERSION)), $(CURRENT_GOVERSION))
	@$(MAKE) -C $(CSCLI_FOLDER) build --no-print-directory
else
	@echo "Required golang version is $(REQUIRE_GOVERSION). The current one is $(CURRENT_GOVERSION). Exiting.."
	@exit 1;
endif


crowdsec:
ifeq ($(lastword $(RESPECT_VERSION)), $(CURRENT_GOVERSION))
	@$(MAKE) -C $(CROWDSEC_FOLDER) build --no-print-directory
else
	@echo "Required golang version is $(REQUIRE_GOVERSION). The current one is $(CURRENT_GOVERSION). Exiting.."
	@exit 1;
endif


cscli_static:
ifeq ($(lastword $(RESPECT_VERSION)), $(CURRENT_GOVERSION))
	@$(MAKE) -C $(CSCLI_FOLDER) static --no-print-directory
else
	@echo "Required golang version is $(REQUIRE_GOVERSION). The current one is $(CURRENT_GOVERSION). Exiting.."
	@exit 1;
endif


crowdsec_static:
ifeq ($(lastword $(RESPECT_VERSION)), $(CURRENT_GOVERSION))
	@$(MAKE) -C $(CROWDSEC_FOLDER) static --no-print-directory
else
	@echo "Required golang version is $(REQUIRE_GOVERSION). The current one is $(CURRENT_GOVERSION). Exiting.."
	@exit 1;
endif

#.PHONY: test
test:
ifeq ($(lastword $(RESPECT_VERSION)), $(CURRENT_GOVERSION))
	@$(MAKE) -C $(CROWDSEC_FOLDER) test --no-print-directory
else
	@echo "Required golang version is $(REQUIRE_GOVERSION). The current one is $(CURRENT_GOVERSION). Exiting.."
	@exit 1;
endif

.PHONY: uninstall
uninstall:
	@rm -rf "$(CFG_PREFIX)" || exit
	@rm -rf "$(DATA_PREFIX)" || exit
	@rm -rf "$(SYSTEMD_PATH_FILE)" || exit

.PHONY: check_release
check_release:
	@if [ -d $(RELDIR) ]; then echo "$(RELDIR) already exists, abort" ;  exit 1 ; fi

.PHONY:
release: check_release build
	@echo Building Release to dir $(RELDIR)
	@mkdir -p $(RELDIR)/cmd/crowdsec
	@mkdir -p $(RELDIR)/cmd/crowdsec-cli
	@cp $(CROWDSEC_FOLDER)/$(CROWDSEC_BIN) $(RELDIR)/cmd/crowdsec
	@cp $(CSCLI_FOLDER)/$(CSCLI_BIN) $(RELDIR)/cmd/crowdsec-cli
	@cp -R ./config/ $(RELDIR)
	@cp wizard.sh $(RELDIR)
	@cp scripts/test_env.sh $(RELDIR)
	@tar cvzf crowdsec-release.tgz $(RELDIR)

=== docs/requirements.txt ===
click==7.1.1
future==0.18.2
Jinja2==2.11.1
joblib==0.14.1
livereload==2.6.1
lunr==0.5.6
Markdown==3.2.1
MarkupSafe==1.1.1
mkdocs==1.1
mkdocs-macros-plugin==0.4.18
mkdocs-material==6.1.0
mkdocs-material-extensions==1.0.1
mkdocs-monorepo-plugin==0.4.11
mkdocs-redirects==1.0.1
nltk==3.5b1
prompt-toolkit==2.0.10
Pygments==2.6.1
pymdown-extensions==7.0
python-markdown-math==0.6
PyYAML==5.3.1
regex==2020.2.20
repackage==0.7.3
six==1.14.0
termcolor==1.1.0
tornado==6.0.4
tqdm==4.43.0
wcwidth==0.1.9

=== cmd/crowdsec-cli/Makefile ===
# Go parameters
GOCMD=go
GOBUILD=$(GOCMD) build
GOCLEAN=$(GOCMD) clean
GOTEST=$(GOCMD) test
GOGET=$(GOCMD) get
BINARY_NAME=cscli
PREFIX?="/"
BIN_PREFIX = $(PREFIX)"/usr/local/bin/"

all: clean build

build: clean
	@$(GOBUILD) $(LD_OPTS) -o $(BINARY_NAME) -v

static: clean
	@$(GOBUILD) -o $(BINARY_NAME) -v -a -tags netgo -ldflags '-w -extldflags "-static"'

install: install-conf install-bin

install-conf:

install-bin:
	@install -v -m 755 -D "$(BINARY_NAME)" "$(BIN_PREFIX)/$(BINARY_NAME)" || exit

uninstall:
	@rm -rf $(CSCLI_CONFIG)
	@rm -rf $(BIN_PREFIX)$(BINARY_NAME)

clean:
	@rm -f $(BINARY_NAME)

=== cmd/crowdsec/Makefile ===
# Go parameters
GOCMD=go
GOBUILD=$(GOCMD) build
GOCLEAN=$(GOCMD) clean
GOTEST=$(GOCMD) test
GOGET=$(GOCMD) get

CROWDSEC_BIN=crowdsec
PREFIX?="/"
CFG_PREFIX = $(PREFIX)"/etc/crowdsec/config/"
BIN_PREFIX = $(PREFIX)"/usr/local/bin/"
DATA_PREFIX = $(PREFIX)"/var/run/crowdsec/"
PID_DIR = $(PREFIX)"/var/run/"

SYSTEMD_PATH_FILE="/etc/systemd/system/crowdsec.service"

all: clean test build

build: clean
	$(GOBUILD) $(LD_OPTS) -o $(CROWDSEC_BIN) -v

static: clean
	$(GOBUILD) -o $(CROWDSEC_BIN) -v -a -tags netgo -ldflags '-w -extldflags "-static"'

test:
	$(GOTEST) -v ./...

clean:
	rm -f $(CROWDSEC_BIN)

.PHONY: install
install: install-conf install-bin

.PHONY: install-conf
install-conf:
	mkdir -p $(DATA_PREFIX) || exit
	(cd ../.. / && find ./data -type f -exec install -Dm 755 "{}" "$(DATA_PREFIX){}" \; && cd ./cmd/crowdsec) || exit
	(cd ../../config && find ./patterns -type f -exec install -Dm 755 "{}" "$(CFG_PREFIX){}" \; && cd ../cmd/crowdsec) || exit
	mkdir -p "$(CFG_PREFIX)" || exit
	mkdir -p "$(CFG_PREFIX)/parsers" || exit
	mkdir -p "$(CFG_PREFIX)/scenarios" || exit
	mkdir -p "$(CFG_PREFIX)/postoverflows" || exit
	mkdir -p "$(CFG_PREFIX)/collections" || exit
	mkdir -p "$(CFG_PREFIX)/patterns" || exit
	install -v -m 755 -D ../../config/prod.yaml "$(CFG_PREFIX)" || exit
	install -v -m 755 -D ../../config/dev.yaml "$(CFG_PREFIX)" || exit
	install -v -m 755 -D ../../config/acquis.yaml "$(CFG_PREFIX)" || exit
	install -v -m 755 -D ../../config/profiles.yaml "$(CFG_PREFIX)" || exit
	install -v -m 755 -D ../../config/api.yaml "$(CFG_PREFIX)" || exit
	mkdir -p $(PID_DIR) || exit
	PID=$(PID_DIR) DATA=$(DATA_PREFIX)"/data/" CFG=$(CFG_PREFIX) envsubst < ../../config/prod.yaml > $(CFG_PREFIX)"/default.yaml"	

.PHONY: install-bin
install-bin:
	install -v -m 755 -D "$(CROWDSEC_BIN)" "$(BIN_PREFIX)/$(CROWDSEC_BIN)" || exit

.PHONY: systemd"$(BIN_PREFI"$(BIN_PREFIX)/$(CROWDSEC_BIN)""$(BIN_PREFIX)/$(CROWDSEC_BIN)"X)/$(CROWDSEC_BIN)"
systemd: install
	CFG=$(CFG_PREFIX) PID=$(PID_DIR) BIN=$(BIN_PREFIX)"/"$(CROWDSEC_BIN) envsubst < ../../config/crowdsec.service > "$(SYSTEMD_PATH_FILE)"
	systemctl daemon-reload

.PHONY: uninstall
uninstall:
	rm -rf $(CFG_PREFIX)
	rm -rf $(DATA_PREFIX)
	rm -f "$(BIN_PREFIX)/$(CROWDSEC_BIN)"
	rm -f "$(SYSTEMD_PATH_FILE)"

## crowdsec 1.0.4

=== debian/changelog ===
crowdsec (1.0.4-1) unstable; urgency=medium

  * New upstream release.
  * Bump copyright years.
  * Bump golang-github-facebook-ent-dev build-dep.
  * Swap Maintainer/Uploaders: the current plan is for me to keep in touch
    with upstream to coordinate packaging work in Debian. Help from fellow
    members of the Debian Go Packaging Team is very welcome, though!
  * Fix typos in the long description, and merge upstream's review.
  * Refresh patch:
     + 0001-use-a-local-machineid-implementation.patch
  * Drop patch (merged upstream):
     + 1001-fix-docker-container-creation-for-metabase-563.patch

 -- Cyril Brulebois <cyril@debamax.com>  Wed, 03 Feb 2021 08:54:24 +0000

crowdsec (1.0.2-1) unstable; urgency=medium

  * Initial release (Closes: #972573): start by shipping binaries,
    while better integration is being worked on with upstream:
    documentation and assisted configuration are coming up.
  * Version some build-deps as earlier versions are known not to work.
  * Use a local machineid implementation instead of depending on an
    extra package:
     + 0001-use-a-local-machineid-implementation.patch
  * Use a syntax that's compatible with version 1.6.0 of the sqlite3
    driver:
     + 0002-add-compatibility-for-older-sqlite-driver.patch
  * Backport upstream fix for golang-github-docker-docker-dev version
    currently in unstable:
     + 1001-fix-docker-container-creation-for-metabase-563.patch
  * Install all files in the build directory so that the testsuite finds
    required test data that's scattered all over the place.
  * Add systemd to Build-Depends for the testsuite, so that it finds
    the journalctl binary.
  * Add lintian overrides for the hardening-no-pie warnings: PIE is not
    relevant for Go packages.

 -- Cyril Brulebois <cyril@debamax.com>  Thu, 14 Jan 2021 02:46:18 +0000

=== debian/control ===
Source: crowdsec
Maintainer: Cyril Brulebois <cyril@debamax.com>
Uploaders: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Section: golang
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-any,
               golang-github-alecaivazis-survey-dev,
               golang-github-antonmedv-expr-dev,
               golang-github-appleboy-gin-jwt-dev,
               golang-github-buger-jsonparser-dev,
               golang-github-coreos-go-systemd-dev,
               golang-github-davecgh-go-spew-dev,
               golang-github-dghubble-sling-dev,
               golang-github-docker-docker-dev,
               golang-github-docker-go-connections-dev,
               golang-github-enescakir-emoji-dev,
               golang-github-facebook-ent-dev (>= 0.5.4),
               golang-github-gin-gonic-gin-dev (>= 1.6.3),
               golang-github-go-co-op-gocron-dev,
               golang-github-go-openapi-errors-dev,
               golang-github-go-openapi-strfmt-dev,
               golang-github-go-openapi-swag-dev,
               golang-github-go-openapi-validate-dev,
               golang-github-go-sql-driver-mysql-dev,
               golang-github-google-go-querystring-dev,
               golang-github-goombaio-namegenerator-dev,
               golang-github-hashicorp-go-version-dev,
               golang-github-logrusorgru-grokky-dev,
               golang-github-mattn-go-sqlite3-dev,
               golang-github-mohae-deepcopy-dev,
               golang-github-nxadm-tail-dev,
               golang-github-olekukonko-tablewriter-dev,
               golang-github-opencontainers-image-spec-dev,
               golang-github-oschwald-geoip2-golang-dev (>= 1.2),
               golang-github-oschwald-maxminddb-golang-dev (>= 1.4),
               golang-github-pkg-errors-dev,
               golang-github-prometheus-client-model-dev,
               golang-github-prometheus-prom2json-dev,
               golang-github-spf13-cobra-dev,
               golang-github-stretchr-testify-dev,
               golang-golang-x-crypto-dev,
               golang-golang-x-mod-dev,
               golang-golang-x-sys-dev,
               golang-gopkg-natefinch-lumberjack.v2-dev,
               golang-gopkg-tomb.v2-dev,
               golang-logrus-dev,
               golang-pq-dev,
               golang-prometheus-client-dev,
               golang-yaml.v2-dev,
               systemd
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/go-team/packages/crowdsec
Vcs-Git: https://salsa.debian.org/go-team/packages/crowdsec.git
Homepage: https://github.com/crowdsecurity/crowdsec
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/crowdsecurity/crowdsec

Package: crowdsec
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Description: lightweight and collaborative security engine
 CrowdSec is a lightweight security engine, able to detect and remedy
 aggressive network behavior. It can leverage and also enrich a
 global community-wide IP reputation database, to help fight online
 cybersec aggressions in a collaborative manner.
 .
 CrowdSec can read many log sources, parse and also enrich them, in
 order to detect specific scenarios, that usually represent malevolent
 behavior. Parsers, Enrichers, and Scenarios are YAML files that can
 be shared and downloaded through a specific Hub, as well as be created
 or adapted locally.
 .
 Detection results are available for CrowdSec, its CLI tools and
 bouncers via an HTTP API. Triggered scenarios lead to an alert, which
 often results in a decision (e.g. IP banned for 4 hours) that can be
 consumed by bouncers (software components enforcing a decision, such
 as an iptables ban, an nginx lua script, or any custom user script).
 .
 The CLI allows users to deploy a Metabase Docker image to provide
 simple-to-deploy dashboards of ongoing activity. The CrowdSec daemon
 is also instrumented with Prometheus to provide observability.
 .
 CrowdSec can be used against live logs (“à la fail2ban”), but can
 also work on cold logs to help, in a forensic context, to build an
 analysis for past events.
 .
 On top of that, CrowdSec aims at sharing detection signals amongst
 all participants, to pre-emptively allow users to block likely
 attackers. To achieve this, minimal meta-information about the attack
 is shared with the CrowdSec organization for further retribution.
 .
 Users can also decide not to take part into the collective effort via
 the central API, but to register on a local API instead.

=== debian/rules ===
#!/usr/bin/make -f

export DH_GOLANG_INSTALL_ALL := 1

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

override_dh_auto_install:
	dh_auto_install -- --no-source

## crowdsec 1.0.9

=== debian/changelog ===
crowdsec (1.0.9-2) unstable; urgency=medium

  * Backport hub patch from upstream to fix false positives due to
    substring matches (https://github.com/crowdsecurity/hub/pull/197):
     + 0009-Improve-http-bad-user-agent-use-regexp-197.patch

 -- Cyril Brulebois <cyril@debamax.com>  Mon, 03 May 2021 07:29:06 +0000

crowdsec (1.0.9-1) unstable; urgency=medium

  * New upstream stable release:
     + Improve documentation.
     + Fix disabled Central API use case: without Central API credentials
       in the relevant config file, crowdsec would still try and establish
       a connection.
  * Add patch to disable broken scenario (ban-report-ssh_bf_report, #181):
     + 0008-hub-disable-broken-scenario.patch
  * Add logrotate config for /var/log/crowdsec{,_api}.log (weekly, 4).

 -- Cyril Brulebois <cyril@debamax.com>  Mon, 15 Mar 2021 01:19:43 +0100

crowdsec (1.0.8-2) unstable; urgency=medium

  * Update postinst to also strip ltsich/ when installing symlinks
    initially (new vendor in recent hub files, in addition to the usual
    crowdsecurity/).

 -- Cyril Brulebois <cyril@debamax.com>  Tue, 02 Mar 2021 01:29:29 +0000

crowdsec (1.0.8-1) unstable; urgency=medium

  * New upstream stable release.
  * Refresh patches:
     + 0001-use-a-local-machineid-implementation.patch (unfuzzy)
     + 0002-add-compatibility-for-older-sqlite-driver.patch
  * Set cwversion variables through debian/rules (build metadata).
  * Add patch so that upstream's crowdsec.service is correct on Debian:
     + 0003-adjust-systemd-unit.patch
  * Really add lintian overrides for hardening-no-pie warnings.
  * Ship patterns below /etc/crowdsec/patterns: they're supposed to be
    stable over time, and it's advised not to modify them, but let's allow
    for some configurability.
  * Include a snapshot of hub files from the master branch, at commit
    d8a8509bdf: hub1. Further updates for a given crowdsec upstream
    version will be numbered hubN. After a while, they will be generated
    from a dedicated vX.Y.Z branch instead of from master.
  * Implement a generate_hub_tarball target in debian/rules to automate
    generating a tarball for hub files.
  * Add patch to disable geoip-enrich in the hub files as it requires
    downloading some files from the network that aren't under the usual
    MIT license:
     + 0004-disable-geoip-enrich.patch
  * Ship a selection of hub files in /usr/share/crowdsec/hub so that
    crowdsec can be set up without having to download data from the
    collaborative hub (https://hub.crowdsec.net/).
  * Ditto for some data files (in /usr/share/crowdsec/data).
  * Use DH_GOLANG_EXCLUDES to avoid including extra Go files from the
    hub into the build directory.
  * Implement an extract_hub_tarball target in debian/rules to automate
    extracting hub files from the tarball.
  * Implement an extract_data_tarball target in debian/rules to automate
    extracting data files from the tarball.
  * Ship crowdsec-cli (automated Golang naming) as cscli (upstream's
    preference).
  * Add patch to adjust the default config:
     + 0005-adjust-config.patch
  * Ship config/config.yaml accordingly, along with the config files it
    references.
  * Also adjust the hub_branch variable in config.yaml, pointing to the
    branch related to the current upstream release instead of master.
  * Create /var/lib/crowdsec/{data,hub} directories.
  * Implement configure in postinst to generate credentials files:
    Implement a simple agent setup with a Local API (LAPI), and with an
    automatic registration to the Central API (CAPI). The latter can be
    disabled by creating a /etc/crowdsec/online_api_credentials.yaml file
    containing a comment (e.g. “# no thanks”) before installing this
    package.
  * Implement purge in postrm. Drop all of /etc/crowdsec except
    online_api_credentials.yaml if this file doesn't seem to have been
    created during CAPI registration (likely because an admin created the
    file in advance to prevent it). Also remove everything below
    /var/lib/crowdsec/{data,hub}, along with log files.
  * Implement custom enable-online-hub and disable-online-hub actions in
    postinst. The latter is called once automatically to make sure the
    offline hub is ready to use. See README.Debian for details.
  * Also enable all items using the offline hub on fresh installation.
  * Add patch advertising `systemctl restart crowdsec` when updating the
    configuration: reload doesn't work at the moment (#656 upstream).
     + 0006-prefer-systemctl-restart.patch
  * Add patch automating switching from the offline hub to the online hub
    when `cscli hub update` is called:
     + 0007-automatically-enable-online-hub.patch
  * Add lintian override accordingly: uses-dpkg-database-directly.
  * Add ca-certificates to Depends for the CAPI registration.
  * Create /etc/machine-id if it doesn't exist already (e.g. in piuparts
    environments).

 -- Cyril Brulebois <cyril@debamax.com>  Tue, 02 Mar 2021 00:25:48 +0000

=== debian/control ===
--- 
+++ 
@@ -60,7 +60,8 @@
 
 Package: crowdsec
 Architecture: any
-Depends: ${misc:Depends},
+Depends: ca-certificates,
+         ${misc:Depends},
          ${shlibs:Depends}
 Built-Using: ${misc:Built-Using}
 Description: lightweight and collaborative security engine

=== debian/rules ===
#!/usr/bin/make -f

export DH_GOLANG_INSTALL_ALL := 1
export DH_GOLANG_EXCLUDES := hub\d+ data\d+

export BUILD_VERSION   := $(shell dpkg-parsechangelog -SVersion)
export BUILD_TAG       := debian
export BUILD_CODENAME  := $(shell awk '/CodeName/ { gsub(/\"/, "", $$2); print $$2 }' RELEASE.json)
export BUILD_GOVERSION := $(shell go version | awk '{ gsub(/^go/, "", $$3); print $$3 }')
export BUILD_DATE      := $(shell TZ=Etc/UTC date +'%F_%T' -d @$(SOURCE_DATE_EPOCH))
export set_cwversion   := -X github.com/crowdsecurity/crowdsec/pkg/cwversion
export LD_FLAGS        := -ldflags '-s -w             \
	$(set_cwversion).Version=$(BUILD_VERSION)     \
	$(set_cwversion).Tag=$(BUILD_TAG)             \
	$(set_cwversion).Codename=$(BUILD_CODENAME)   \
	$(set_cwversion).GoVersion=$(BUILD_GOVERSION) \
	$(set_cwversion).BuildDate=$(BUILD_DATE)      \
'

# Use 1 for a new upstream release, and bump it when an update of the
# hub files is desired while the upstream version doesn't change. See
# below for the generate_hub_tarball target:
export DATA_ID    := 1
export HUB_ID     := 1
export HUB_BRANCH := master
export HUB_DIR    := ../hub
export U_VERSION  := $(shell dpkg-parsechangelog -SVersion|sed 's/-.*//')

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

override_dh_auto_build:
	dh_auto_build -- $(LD_FLAGS)

override_dh_auto_install:
	dh_auto_install -- --no-source

override_dh_install:
	dh_install
	# Switch from Golang naming to upstream-desired naming:
	mv debian/crowdsec/usr/bin/crowdsec-cli \
		debian/crowdsec/usr/bin/cscli
	# Adjust the hub branch according to the upstream version:
	sed "s/\(.*hub_branch:\) master/\1 v$(U_VERSION)/" -i debian/crowdsec/etc/crowdsec/config.yaml
	# Drop unit tests from the hub:
	find debian/crowdsec/usr/share/crowdsec/hub -depth -name '.tests' -exec rm -rf '{}' ';'


### Maintainer targets:

generate_hub_tarball:
	cd $(HUB_DIR) && git archive --prefix hub$(HUB_ID)/ $(HUB_BRANCH) | gzip -9 > ../crowdsec_$(U_VERSION).orig-hub$(HUB_ID).tar.gz \
	&& echo "Generated hub tarball from branch $(HUB_BRANCH), at commit `git show $(HUB_BRANCH) | awk '/^commit / {print $$2; quit}' | cut -b -10`"

extract_hub_tarball:
	tar xf ../crowdsec_$(U_VERSION).orig-hub$(HUB_ID).tar.gz

extract_data_tarball:
	tar xf ../crowdsec_$(U_VERSION).orig-data$(HUB_ID).tar.gz

## crowdsec 1.4.2

=== Makefile ===

ifeq ($(OS), Windows_NT)
	SHELL := pwsh.exe
	.SHELLFLAGS := -NoProfile -Command
	CS_ROOT = $(shell (Get-Location).Path)
	SYSTEM = windows
	EXT = .exe
else
	CS_ROOT ?= $(shell pwd)
	SYSTEM ?= $(shell uname -s | tr '[A-Z]' '[a-z]')
endif

ifneq ("$(wildcard $(CURDIR)/platform/$(SYSTEM).mk)", "")
	include $(CURDIR)/platform/$(SYSTEM).mk
else
	include $(CURDIR)/platform/linux.mk
endif

ifneq ($(OS), Windows_NT)
	include $(CS_ROOT)/platform/unix_common.mk
endif

CROWDSEC_FOLDER = ./cmd/crowdsec
CSCLI_FOLDER = ./cmd/crowdsec-cli/

HTTP_PLUGIN_FOLDER = ./plugins/notifications/http
SLACK_PLUGIN_FOLDER = ./plugins/notifications/slack
SPLUNK_PLUGIN_FOLDER = ./plugins/notifications/splunk
EMAIL_PLUGIN_FOLDER = ./plugins/notifications/email
DUMMY_PLUGIN_FOLDER = ./plugins/notifications/dummy

HTTP_PLUGIN_BIN = notification-http$(EXT)
SLACK_PLUGIN_BIN = notification-slack$(EXT)
SPLUNK_PLUGIN_BIN = notification-splunk$(EXT)
EMAIL_PLUGIN_BIN = notification-email$(EXT)
DUMMY_PLUGIN_BIN= notification-dummy$(EXT)

HTTP_PLUGIN_CONFIG = http.yaml
SLACK_PLUGIN_CONFIG = slack.yaml
SPLUNK_PLUGIN_CONFIG = splunk.yaml
EMAIL_PLUGIN_CONFIG = email.yaml

CROWDSEC_BIN = crowdsec$(EXT)
CSCLI_BIN = cscli$(EXT)
BUILD_CMD = build

MINIMUM_SUPPORTED_GO_MAJOR_VERSION = 1
MINIMUM_SUPPORTED_GO_MINOR_VERSION = 17
GO_VERSION_VALIDATION_ERR_MSG = Golang version ($(BUILD_GOVERSION)) is not supported, please use at least $(MINIMUM_SUPPORTED_GO_MAJOR_VERSION).$(MINIMUM_SUPPORTED_GO_MINOR_VERSION)

LD_OPTS_VARS= \
-X 'github.com/crowdsecurity/crowdsec/cmd/crowdsec.bincoverTesting=$(BINCOVER_TESTING)' \
-X 'github.com/crowdsecurity/crowdsec/cmd/crowdsec-cli.bincoverTesting=$(BINCOVER_TESTING)' \
-X 'github.com/crowdsecurity/crowdsec/pkg/cwversion.Version=$(BUILD_VERSION)' \
-X 'github.com/crowdsecurity/crowdsec/pkg/cwversion.BuildDate=$(BUILD_TIMESTAMP)' \
-X 'github.com/crowdsecurity/crowdsec/pkg/cwversion.Codename=$(BUILD_CODENAME)' \
-X 'github.com/crowdsecurity/crowdsec/pkg/cwversion.Tag=$(BUILD_TAG)' \
-X 'github.com/crowdsecurity/crowdsec/pkg/cwversion.GoVersion=$(BUILD_GOVERSION)' \
-X 'github.com/crowdsecurity/crowdsec/pkg/csconfig.defaultConfigDir=$(DEFAULT_CONFIGDIR)' \
-X 'github.com/crowdsecurity/crowdsec/pkg/csconfig.defaultDataDir=$(DEFAULT_DATADIR)'

ifdef BUILD_STATIC
	export LD_OPTS=-ldflags "-s -w $(LD_OPTS_VARS) -extldflags '-static'" -tags netgo,osusergo,sqlite_omit_load_extension
else
	export LD_OPTS=-ldflags "-s -w $(LD_OPTS_VARS)"
endif

GOCMD = go
GOTEST = $(GOCMD) test

RELDIR = crowdsec-$(BUILD_VERSION)

.PHONY: build
build: goversion crowdsec cscli plugins

.PHONY: all
all: clean test build

.PHONY: plugins
plugins: http-plugin slack-plugin splunk-plugin email-plugin dummy-plugin

.PHONY: goversion
goversion:
ifneq ($(OS), Windows_NT)
	@if [ $(GO_MAJOR_VERSION) -gt $(MINIMUM_SUPPORTED_GO_MAJOR_VERSION) ]; then \
		exit 0 ;\
	elif [ $(GO_MAJOR_VERSION) -lt $(MINIMUM_SUPPORTED_GO_MAJOR_VERSION) ]; then \
		echo '$(GO_VERSION_VALIDATION_ERR_MSG)';\
		exit 1; \
	elif [ $(GO_MINOR_VERSION) -lt $(MINIMUM_SUPPORTED_GO_MINOR_VERSION) ] ; then \
		echo '$(GO_VERSION_VALIDATION_ERR_MSG)';\
		exit 1; \
	fi
else
	# This needs Set-ExecutionPolicy -Scope CurrentUser Unrestricted
	@$(CS_ROOT)/scripts/check_go_version.ps1 $(MINIMUM_SUPPORTED_GO_MAJOR_VERSION) $(MINIMUM_SUPPORTED_GO_MINOR_VERSION)
endif

.PHONY: clean
clean: testclean
	@$(MAKE) -C $(CROWDSEC_FOLDER) clean --no-print-directory RM="$(RM)" WIN_IGNORE_ERR="$(WIN_IGNORE_ERR)" CP="$(CP)" CPR="$(CPR)" MKDIR="$(MKDIR)"
	@$(MAKE) -C $(CSCLI_FOLDER) clean --no-print-directory RM="$(RM)" WIN_IGNORE_ERR="$(WIN_IGNORE_ERR)" CP="$(CP)" CPR="$(CPR)" MKDIR="$(MKDIR)"
	@$(RM) $(CROWDSEC_BIN) $(WIN_IGNORE_ERR)
	@$(RM) $(CSCLI_BIN) $(WIN_IGNORE_ERR)
	@$(RM) *.log $(WIN_IGNORE_ERR)
	@$(RM) crowdsec-release.tgz $(WIN_IGNORE_ERR)
	@$(RM) crowdsec-release-static.tgz $(WIN_IGNORE_ERR)
	@$(RM) $(HTTP_PLUGIN_FOLDER)/$(HTTP_PLUGIN_BIN) $(WIN_IGNORE_ERR)
	@$(RM) $(SLACK_PLUGIN_FOLDER)/$(SLACK_PLUGIN_BIN) $(WIN_IGNORE_ERR)
	@$(RM) $(SPLUNK_PLUGIN_FOLDER)/$(SPLUNK_PLUGIN_BIN) $(WIN_IGNORE_ERR)
	@$(RM) $(EMAIL_PLUGIN_FOLDER)/$(EMAIL_PLUGIN_BIN) $(WIN_IGNORE_ERR)
	@$(RM) $(DUMMY_PLUGIN_FOLDER)/$(DUMMY_PLUGIN_BIN) $(WIN_IGNORE_ERR)


cscli: goversion
	@$(MAKE) -C $(CSCLI_FOLDER) build --no-print-directory GOARCH=$(GOARCH) GOOS=$(GOOS) RM="$(RM)" WIN_IGNORE_ERR="$(WIN_IGNORE_ERR)" CP="$(CP)" CPR="$(CPR)" MKDIR="$(MKDIR)"

cscli-bincover: goversion
	@GOARCH=$(GOARCH) GOOS=$(GOOS) $(MAKE) -C $(CSCLI_FOLDER) build-bincover --no-print-directory

crowdsec: goversion
	@$(MAKE) -C $(CROWDSEC_FOLDER) build --no-print-directory GOARCH=$(GOARCH) GOOS=$(GOOS) RM="$(RM)" WIN_IGNORE_ERR="$(WIN_IGNORE_ERR)" CP="$(CP)" CPR="$(CPR)" MKDIR="$(MKDIR)"

crowdsec-bincover: goversion
	@GOARCH=$(GOARCH) GOOS=$(GOOS) $(MAKE) -C $(CROWDSEC_FOLDER) build-bincover --no-print-directory

http-plugin: goversion
	@$(MAKE) -C $(HTTP_PLUGIN_FOLDER) build --no-print-directory GOARCH=$(GOARCH) GOOS=$(GOOS) RM="$(RM)" WIN_IGNORE_ERR="$(WIN_IGNORE_ERR)" CP="$(CP)" CPR="$(CPR)" MKDIR="$(MKDIR)"

slack-plugin: goversion
	@$(MAKE) -C $(SLACK_PLUGIN_FOLDER) build --no-print-directory GOARCH=$(GOARCH) GOOS=$(GOOS) RM="$(RM)" WIN_IGNORE_ERR="$(WIN_IGNORE_ERR)" CP="$(CP)" CPR="$(CPR)" MKDIR="$(MKDIR)"

splunk-plugin: goversion
	@$(MAKE) -C $(SPLUNK_PLUGIN_FOLDER) build --no-print-directory GOARCH=$(GOARCH) GOOS=$(GOOS) RM="$(RM)" WIN_IGNORE_ERR="$(WIN_IGNORE_ERR)" WIN_IGNORE_ERR="$(WIN_IGNORE_ERR)" CP="$(CP)" CPR="$(CPR)" MKDIR="$(MKDIR)"

email-plugin: goversion
	@$(MAKE) -C $(EMAIL_PLUGIN_FOLDER) build --no-print-directory GOARCH=$(GOARCH) GOOS=$(GOOS) RM="$(RM)" WIN_IGNORE_ERR="$(WIN_IGNORE_ERR)" CP="$(CP)" CPR="$(CPR)" MKDIR="$(MKDIR)"

dummy-plugin: goversion
	$(MAKE) -C $(DUMMY_PLUGIN_FOLDER) build --no-print-directory GOARCH=$(GOARCH) GOOS=$(GOOS) RM="$(RM)" WIN_IGNORE_ERR="$(WIN_IGNORE_ERR)" CP="$(CP)" CPR="$(CPR)" MKDIR="$(MKDIR)"

.PHONY: testclean
testclean: bats-clean
	@$(RM) pkg/apiserver/ent $(WIN_IGNORE_ERR)
	@$(RM) pkg/cwhub/hubdir $(WIN_IGNORE_ERR)
	@$(RM) pkg/cwhub/install $(WIN_IGNORE_ERR)
	@$(RM) pkg/types/example.txt $(WIN_IGNORE_ERR)

.PHONY: test
test: export AWS_ENDPOINT_FORCE=http://localhost:4566
test: goversion
	@echo 'NOTE: You need Docker, docker-compose and run "make localstack" in a separate shell ("make localstack-stop" to terminate it)'
	$(GOTEST) $(LD_OPTS) ./...

.PHONY: localstack
localstack:
	docker-compose -f tests/localstack/docker-compose.yml up

.PHONY: localstack-stop
localstack-stop:
	docker-compose -f tests/localstack/docker-compose.yml down

package-common:
	@echo "Building Release to dir $(RELDIR)"
	@$(MKDIR) $(RELDIR)/cmd/crowdsec
	@$(MKDIR) $(RELDIR)/cmd/crowdsec-cli
	@$(MKDIR) $(RELDIR)/$(subst ./,,$(HTTP_PLUGIN_FOLDER))
	@$(MKDIR) $(RELDIR)/$(subst ./,,$(SLACK_PLUGIN_FOLDER))
	@$(MKDIR) $(RELDIR)/$(subst ./,,$(SPLUNK_PLUGIN_FOLDER))
	@$(MKDIR) $(RELDIR)/$(subst ./,,$(EMAIL_PLUGIN_FOLDER))

	@$(CP) $(CROWDSEC_FOLDER)/$(CROWDSEC_BIN) $(RELDIR)/cmd/crowdsec
	@$(CP) $(CSCLI_FOLDER)/$(CSCLI_BIN) $(RELDIR)/cmd/crowdsec-cli

	@$(CP) $(HTTP_PLUGIN_FOLDER)/$(HTTP_PLUGIN_BIN) $(RELDIR)/$(subst ./,,$(HTTP_PLUGIN_FOLDER))
	@$(CP) $(SLACK_PLUGIN_FOLDER)/$(SLACK_PLUGIN_BIN) $(RELDIR)/$(subst ./,,$(SLACK_PLUGIN_FOLDER))
	@$(CP) $(SPLUNK_PLUGIN_FOLDER)/$(SPLUNK_PLUGIN_BIN) $(RELDIR)/$(subst ./,,$(SPLUNK_PLUGIN_FOLDER))
	@$(CP) $(EMAIL_PLUGIN_FOLDER)/$(EMAIL_PLUGIN_BIN) $(RELDIR)/$(subst ./,,$(EMAIL_PLUGIN_FOLDER))

	@$(CP) $(HTTP_PLUGIN_FOLDER)/$(HTTP_PLUGIN_CONFIG) $(RELDIR)/$(subst ./,,$(HTTP_PLUGIN_FOLDER))
	@$(CP) $(SLACK_PLUGIN_FOLDER)/$(SLACK_PLUGIN_CONFIG) $(RELDIR)/$(subst ./,,$(SLACK_PLUGIN_FOLDER))
	@$(CP) $(SPLUNK_PLUGIN_FOLDER)/$(SPLUNK_PLUGIN_CONFIG) $(RELDIR)/$(subst ./,,$(SPLUNK_PLUGIN_FOLDER))
	@$(CP) $(EMAIL_PLUGIN_FOLDER)/$(EMAIL_PLUGIN_CONFIG) $(RELDIR)/$(subst ./,,$(EMAIL_PLUGIN_FOLDER))

	@$(CPR) ./config $(RELDIR)
	@$(CP) wizard.sh $(RELDIR)
	@$(CP) scripts/test_env.sh $(RELDIR)
	@$(CP) scripts/test_env.ps1 $(RELDIR)

.PHONY: package
package: package-common
	@tar cvzf crowdsec-release.tgz $(RELDIR)

.PHONY: check_release
check_release:
ifneq ($(OS), Windows_NT)
	@if [ -d $(RELDIR) ]; then echo "$(RELDIR) already exists, abort" ;  exit 1 ; fi
else
	@if (Test-Path -Path $(RELDIR)) { echo "$(RELDIR) already exists, abort" ;  exit 1 ; }
endif

.PHONY: release
release: check_release build package

.PHONY: windows_installer
windows_installer: build
	@.\make_installer.ps1 -version $(BUILD_VERSION)

.PHONY: chocolatey
chocolatey: windows_installer
	@.\make_chocolatey.ps1 -version $(BUILD_VERSION)

include tests/bats.mk

=== debian/changelog ===
crowdsec (1.4.2-2) unstable; urgency=medium

  * Fix FTBFS with -A (`Architecture: all` only) by adjusting the contents
    of the crowdsec binary package within override_dh_install-arch instead
    of override_dh_install.

 -- Cyril Brulebois <cyril@debamax.com>  Tue, 14 Feb 2023 23:54:17 +0000

crowdsec (1.4.2-1) unstable; urgency=medium

  * New upstream release (Closes: #1011665).
  * Add patches:
     - 0008-r3labs-diff-versions.patch: adjust import path for
       r3labs/diff.
     - 0009-disable-kafka-acquisition-module.patch: this would require
       introducing a number of new packages.
     - 0010-disable-some-tests.patch: cloudwatch, kinesis, and docker are
       fine for integration tests but would require new packages and
       setting up a test infrastructure.
     - 0011-refresh-protobuf-code.patch: this avoids protobuf version
       mismatch.
     - 0012-work-around-buggy-testparse-test.patch: bump expected year
       when parsing year-less timestamps.
  * Refresh patches:
     - 0003-adjust-systemd-unit.patch
     - 0004-disable-geoip-enrich.patch
     - 0005-adjust-config.patch
     - 0007-automatically-enable-online-hub.patch
  * Delete obsolete patches:
     - 0001-use-a-local-machineid-implementation.patch (a separate package
       is available now)
     - 0002-add-compatibility-for-older-sqlite-driver.patch
     - 0006-prefer-systemctl-restart.patch (bug fixed upstream)
     - 0008-hub-disable-broken-scenario.patch
     - 0009-Improve-http-bad-user-agent-use-regexp-197.patch
     - 0010-5ae69aa293-fix-stacktrace-when-mmdb-files-are-not-present.patch
     - 0011-4dbbd4b3c4-automatically-download-files-when-needed.patch
  * Update dependencies:
     - Add golang-entgo-ent-dev
     - Add golang-github-alexliesenfeld-health-dev
     - Add golang-github-aquasecurity-table-dev
     - Add golang-github-beevik-etree-dev
     - Add golang-github-blackfireio-osinfo-dev
     - Add golang-github-c-robinson-iplib-dev
     - Add golang-github-confluentinc-bincover-dev
     - Add golang-github-crowdsecurity-dlog-dev
     - Add golang-github-crowdsecurity-grokky-dev
     - Add golang-github-crowdsecurity-machineid-dev
     - Add golang-github-hashicorp-go-plugin-dev
     - Add golang-github-ivanpirog-coloredcobra-dev
     - Add golang-github-jackc-pgx-v4-dev
     - Add golang-github-jarcoal-httpmock-dev
     - Add golang-github-jszwec-csvutil-dev
     - Add golang-github-masterminds-sprig-dev
     - Add golang-github-pbnjay-memory-dev
     - Add golang-github-r3labs-diff-dev
     - Add golang-github-slack-go-slack-dev
     - Add golang-github-texttheater-golang-levenshtein-dev
     - Add golang-github-xhit-go-simple-mail-dev
     - Bump golang-github-gin-gonic-gin-dev from 1.6.3 to 1.8.1
     - Delete golang-github-facebook-ent-dev (replaced with
       golang-entgo-ent-dev)
     - Delete golang-github-logrusorgru-grokky-dev (replaced with
       golang-github-crowdsecurity-grokky-dev)
     - Delete golang-github-olekukonko-tablewriter-dev (no longer used)
     - Replace golang-logrus-dev with golang-github-sirupsen-logrus-dev
     - Replace golang-pq-dev with golang-github-lib-pq-dev
     - Replace golang-prometheus-client-dev with
       golang-github-prometheus-client-golang-dev
     - Replace golang-yaml.v2-dev with golang-gopkg-yaml.v2-dev
     - Add python3 (for the testsuite).
  * Adjust variables passed to the build system via LD_FLAGS:
     - Set BUILD_CODENAME from platform/unix_common.mk
     - Set BUILD_TIMESTAMP, replacing BUILD_DATE.
     - Stop setting BUILD_GOVERSION, now determined at runtime.
  * Avoid “date: invalid date ‘@’” warnings when using ancillary rules.
  * Include a snapshot of hub files from the v1.4.2 branch, at commit
    73d2edaaf1.
  * Add README.source, documenting additional tarballs.
  * Include a snapshot of data files, at commit 03c7a30d70, plus
    Cloudflare IPv4 and IPv6 addresses as of 2022-12-15.
  * Upon upgrade, only enable items that are new since 1.0.9, instead
    of enabling all of them (which could enable again things that were
    disabled by the admin).
  * Adjust lintian overrides:
     - Adjust syntax to avoid mismatched overrides.
     - Extend hardening-no-pie to plugins.
     - Avoid a false positive with shell-script-fails-syntax-check.
     - Avoid a false positive with broken-gz.
     - Silence script-not-executable and unusual-interpreter bats
       for *.bats file (test files).

 -- Cyril Brulebois <cyril@debamax.com>  Tue, 14 Feb 2023 22:32:27 +0000

crowdsec (1.0.9-4) experimental; urgency=medium

  * Add square brackets around paths for hardening-no-pie lintian overrides.
  * Add library package, which is a build dependency bouncers require.
  * Adjust debhelper control files for the switch from building a single
    package to building multiple packages (mostly marking existing files
    with a crowdsec. prefix).
  * Adjust setting BUILD_CODENAME, avoiding an awk(ward) warning.

 -- Cyril Brulebois <cyril@debamax.com>  Fri, 06 May 2022 04:48:13 +0000

crowdsec (1.0.9-3) unstable; urgency=medium

  * Backport upstream patches to deal with missing MMDB files gracefully
    (geolocation files aren't shipped by default):
      - 5ae69aa293: fix stacktrace when mmdb files are not present (#935)
      - 4dbbd4b3c4: automatically download files when needed (#895), so
        that switching to the online hub doesn't require extra steps to
        fetch files.

 -- Cyril Brulebois <cyril@debamax.com>  Sat, 04 Dec 2021 05:03:33 +0100

=== debian/control ===
--- 
+++ 
@@ -7,18 +7,27 @@
 Build-Depends: debhelper-compat (= 13),
                dh-golang,
                golang-any,
+               golang-entgo-ent-dev,
                golang-github-alecaivazis-survey-dev,
+               golang-github-alexliesenfeld-health-dev,
                golang-github-antonmedv-expr-dev,
                golang-github-appleboy-gin-jwt-dev,
+               golang-github-aquasecurity-table-dev,
+               golang-github-beevik-etree-dev,
+               golang-github-blackfireio-osinfo-dev,
                golang-github-buger-jsonparser-dev,
+               golang-github-c-robinson-iplib-dev,
+               golang-github-confluentinc-bincover-dev,
                golang-github-coreos-go-systemd-dev,
+               golang-github-crowdsecurity-dlog-dev,
+               golang-github-crowdsecurity-grokky-dev,
+               golang-github-crowdsecurity-machineid-dev,
                golang-github-davecgh-go-spew-dev,
                golang-github-dghubble-sling-dev,
                golang-github-docker-docker-dev,
                golang-github-docker-go-connections-dev,
                golang-github-enescakir-emoji-dev,
-               golang-github-facebook-ent-dev (>= 0.5.4),
-               golang-github-gin-gonic-gin-dev (>= 1.6.3),
+               golang-github-gin-gonic-gin-dev (>= 1.8.1),
                golang-github-go-co-op-gocron-dev,
                golang-github-go-openapi-errors-dev,
                golang-github-go-openapi-strfmt-dev,
@@ -27,29 +36,39 @@
                golang-github-go-sql-driver-mysql-dev,
                golang-github-google-go-querystring-dev,
                golang-github-goombaio-namegenerator-dev,
+               golang-github-hashicorp-go-plugin-dev,
                golang-github-hashicorp-go-version-dev,
-               golang-github-logrusorgru-grokky-dev,
+               golang-github-ivanpirog-coloredcobra-dev,
+               golang-github-jackc-pgx-v4-dev,
+               golang-github-jarcoal-httpmock-dev,
+               golang-github-jszwec-csvutil-dev,
+               golang-github-lib-pq-dev,
+               golang-github-masterminds-sprig-dev,
                golang-github-mattn-go-sqlite3-dev,
                golang-github-mohae-deepcopy-dev,
                golang-github-nxadm-tail-dev,
-               golang-github-olekukonko-tablewriter-dev,
                golang-github-opencontainers-image-spec-dev,
                golang-github-oschwald-geoip2-golang-dev (>= 1.2),
                golang-github-oschwald-maxminddb-golang-dev (>= 1.4),
+               golang-github-pbnjay-memory-dev,
                golang-github-pkg-errors-dev,
+               golang-github-prometheus-client-golang-dev,
                golang-github-prometheus-client-model-dev,
                golang-github-prometheus-prom2json-dev,
+               golang-github-r3labs-diff-dev,
+               golang-github-sirupsen-logrus-dev,
+               golang-github-slack-go-slack-dev,
                golang-github-spf13-cobra-dev,
                golang-github-stretchr-testify-dev,
+               golang-github-texttheater-golang-levenshtein-dev,
+               golang-github-xhit-go-simple-mail-dev,
                golang-golang-x-crypto-dev,
                golang-golang-x-mod-dev,
                golang-golang-x-sys-dev,
                golang-gopkg-natefinch-lumberjack.v2-dev,
                golang-gopkg-tomb.v2-dev,
-               golang-logrus-dev,
-               golang-pq-dev,
-               golang-prometheus-client-dev,
-               golang-yaml.v2-dev,
+               golang-gopkg-yaml.v2-dev,
+               python3,
                systemd
 Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/go-team/packages/crowdsec
@@ -97,3 +116,77 @@
  .
  Users can also decide not to take part into the collective effort via
  the central API, but to register on a local API instead.
+
+Package: golang-github-crowdsecurity-crowdsec-dev
+Architecture: all
+Multi-Arch: foreign
+Depends: golang-entgo-ent-dev,
+         golang-github-alecaivazis-survey-dev,
+         golang-github-alexliesenfeld-health-dev,
+         golang-github-antonmedv-expr-dev,
+         golang-github-appleboy-gin-jwt-dev,
+         golang-github-aquasecurity-table-dev,
+         golang-github-beevik-etree-dev,
+         golang-github-blackfireio-osinfo-dev,
+         golang-github-buger-jsonparser-dev,
+         golang-github-c-robinson-iplib-dev,
+         golang-github-confluentinc-bincover-dev,
+         golang-github-coreos-go-systemd-dev,
+         golang-github-crowdsecurity-dlog-dev,
+         golang-github-crowdsecurity-grokky-dev,
+         golang-github-crowdsecurity-machineid-dev,
+         golang-github-davecgh-go-spew-dev,
+         golang-github-dghubble-sling-dev,
+         golang-github-docker-docker-dev,
+         golang-github-docker-go-connections-dev,
+         golang-github-enescakir-emoji-dev,
+         golang-github-gin-gonic-gin-dev (>= 1.8.1),
+         golang-github-go-co-op-gocron-dev,
+         golang-github-go-openapi-errors-dev,
+         golang-github-go-openapi-strfmt-dev,
+         golang-github-go-openapi-swag-dev,
+         golang-github-go-openapi-validate-dev,
+         golang-github-go-sql-driver-mysql-dev,
+         golang-github-google-go-querystring-dev,
+         golang-github-goombaio-namegenerator-dev,
+         golang-github-hashicorp-go-plugin-dev,
+         golang-github-hashicorp-go-version-dev,
+         golang-github-ivanpirog-coloredcobra-dev,
+         golang-github-jackc-pgx-v4-dev,
+         golang-github-jarcoal-httpmock-dev,
+         golang-github-jszwec-csvutil-dev,
+         golang-github-lib-pq-dev,
+         golang-github-masterminds-sprig-dev,
+         golang-github-mattn-go-sqlite3-dev,
+         golang-github-mohae-deepcopy-dev,
+         golang-github-nxadm-tail-dev,
+         golang-github-opencontainers-image-spec-dev,
+         golang-github-oschwald-geoip2-golang-dev (>= 1.2),
+         golang-github-oschwald-maxminddb-golang-dev (>= 1.4),
+         golang-github-pbnjay-memory-dev,
+         golang-github-pkg-errors-dev,
+         golang-github-prometheus-client-golang-dev,
+         golang-github-prometheus-client-model-dev,
+         golang-github-prometheus-prom2json-dev,
+         golang-github-r3labs-diff-dev,
+         golang-github-sirupsen-logrus-dev,
+         golang-github-slack-go-slack-dev,
+         golang-github-spf13-cobra-dev,
+         golang-github-stretchr-testify-dev,
+         golang-github-texttheater-golang-levenshtein-dev,
+         golang-github-xhit-go-simple-mail-dev,
+         golang-golang-x-crypto-dev,
+         golang-golang-x-mod-dev,
+         golang-golang-x-sys-dev,
+         golang-gopkg-natefinch-lumberjack.v2-dev,
+         golang-gopkg-tomb.v2-dev,
+         golang-gopkg-yaml.v2-dev,
+         python3,
+         ${misc:Depends}
+Description: lightweight and collaborative security engine - library
+ CrowdSec is a lightweight security engine, able to detect and remedy
+ aggressive network behavior. It can leverage and also enrich a
+ global community-wide IP reputation database, to help fight online
+ cybersec aggressions in a collaborative manner.
+ .
+ This package contains the development files.

=== debian/rules ===
--- 
+++ 
@@ -3,18 +3,26 @@
 export DH_GOLANG_INSTALL_ALL := 1
 export DH_GOLANG_EXCLUDES := hub\d+ data\d+
 
+# Make sure ancillary rules don't generate errors, since the following
+# variable is only set while building:
+ifneq (,$(SOURCE_DATE_EPOCH))
+	now := @$(SOURCE_DATE_EPOCH)
+else
+	now := now
+endif
+
+# Upstream's Makefile would take care of this, but we're building via
+# dh_auto_build in golang mode, instead of using make:
 export BUILD_VERSION   := $(shell dpkg-parsechangelog -SVersion)
 export BUILD_TAG       := debian
-export BUILD_CODENAME  := $(shell awk '/CodeName/ { gsub(/\"/, "", $$2); print $$2 }' RELEASE.json)
-export BUILD_GOVERSION := $(shell go version | awk '{ gsub(/^go/, "", $$3); print $$3 }')
-export BUILD_DATE      := $(shell TZ=Etc/UTC date +'%F_%T' -d @$(SOURCE_DATE_EPOCH))
+export BUILD_CODENAME  := $(shell perl -ne 'print $$1 if /^BUILD_CODENAME="(.+)"$$/' platform/unix_common.mk)
+export BUILD_TIMESTAMP := $(shell TZ=Etc/UTC date +'%F_%T' -d $(now))
 export set_cwversion   := -X github.com/crowdsecurity/crowdsec/pkg/cwversion
 export LD_FLAGS        := -ldflags '-s -w             \
 	$(set_cwversion).Version=$(BUILD_VERSION)     \
 	$(set_cwversion).Tag=$(BUILD_TAG)             \
 	$(set_cwversion).Codename=$(BUILD_CODENAME)   \
-	$(set_cwversion).GoVersion=$(BUILD_GOVERSION) \
-	$(set_cwversion).BuildDate=$(BUILD_DATE)      \
+	$(set_cwversion).BuildDate=$(BUILD_TIMESTAMP) \
 '
 
 # Use 1 for a new upstream release, and bump it when an update of the
@@ -22,7 +30,7 @@
 # below for the generate_hub_tarball target:
 export DATA_ID    := 1
 export HUB_ID     := 1
-export HUB_BRANCH := master
+export HUB_BRANCH := origin/v1.4.2
 export HUB_DIR    := ../hub
 export U_VERSION  := $(shell dpkg-parsechangelog -SVersion|sed 's/-.*//')
 
@@ -33,7 +41,7 @@
 	dh_auto_build -- $(LD_FLAGS)
 
 override_dh_auto_install:
-	dh_auto_install -- --no-source
+	dh_auto_install --
 
 override_dh_install:
 	dh_install
